Commit 2475e634758577baad4a54f4585c7fa9a638ae73

Authored by David Feng
Committed by Albert ARIBAUD
1 parent 129168290a

arm64: MAKEALL, filter armv8 boards from LIST_arm

Signed-off-by: David Feng <fenghua@phytium.com.cn>

Showing 1 changed file with 11 additions and 1 deletions Inline Diff

1 #!/bin/bash 1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board 2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and 3 # configurations with minimal verbosity, showing only warnings and
4 # errors. 4 # errors.
5 # 5 #
6 # SPDX-License-Identifier: GPL-2.0+ 6 # SPDX-License-Identifier: GPL-2.0+
7 7
8 usage() 8 usage()
9 { 9 {
10 # if exiting with 0, write to stdout, else write to stderr 10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0} 11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2 12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF 13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build] 14 Usage: MAKEALL [options] [--] [boards-to-build]
15 15
16 Options: 16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH 17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU 18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR 19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC 20 -s SOC, --soc SOC Build all boards with soc SOC
21 -b BOARD, --board BOARD Build all boards with board name BOARD 21 -b BOARD, --board BOARD Build all boards with board name BOARD
22 -l, --list List all targets to be built 22 -l, --list List all targets to be built
23 -m, --maintainers List all targets and maintainer email 23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails 24 -M, --mails List all targets and all affilated emails
25 -C, --check Enable build checking 25 -C, --check Enable build checking
26 -n, --continue Continue (skip boards already built) 26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored 27 -r, --rebuild-errors Rebuild any boards that errored
28 -h, --help This help output 28 -h, --help This help output
29 29
30 Selections by these options are logically ANDed; if the same option 30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR" 31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or 32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are 33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info. 34 always build additionally. See the boards.cfg file for more info.
35 35
36 If no boards are specified, then the default is "powerpc". 36 If no boards are specified, then the default is "powerpc".
37 37
38 Environment variables: 38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto) 39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "") 40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for 41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 architecture "ARCH". Substitute "ARCH" for any 42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "") 43 supported architecture (default: "")
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/) 44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./) 45 BUILD_DIR output build directory (default: ./)
46 BUILD_NBUILDS number of parallel targets (default: 1) 46 BUILD_NBUILDS number of parallel targets (default: 1)
47 47
48 Examples: 48 Examples:
49 - build all Power Architecture boards: 49 - build all Power Architecture boards:
50 MAKEALL -a powerpc 50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc 51 MAKEALL --arch powerpc
52 MAKEALL powerpc 52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd": 53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd 54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens": 55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens 56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards: 57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx 58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF 59 EOF
60 exit ${ret} 60 exit ${ret}
61 } 61 }
62 62
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr" 63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors" 64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
65 65
66 # Option processing based on util-linux-2.13/getopt-parse.bash 66 # Option processing based on util-linux-2.13/getopt-parse.bash
67 67
68 # Note that we use `"$@"' to let each command-line parameter expand to a 68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential! 69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of 70 # We need TEMP as the `eval set --' would nuke the return value of
71 # getopt. 71 # getopt.
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \ 72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73 -n 'MAKEALL' -- "$@"` 73 -n 'MAKEALL' -- "$@"`
74 74
75 [ $? != 0 ] && usage 1 75 [ $? != 0 ] && usage 1
76 76
77 # Note the quotes around `$TEMP': they are essential! 77 # Note the quotes around `$TEMP': they are essential!
78 eval set -- "$TEMP" 78 eval set -- "$TEMP"
79 79
80 SELECTED='' 80 SELECTED=''
81 ONLY_LIST='' 81 ONLY_LIST=''
82 PRINT_MAINTS='' 82 PRINT_MAINTS=''
83 MAINTAINERS_ONLY='' 83 MAINTAINERS_ONLY=''
84 CONTINUE='' 84 CONTINUE=''
85 REBUILD_ERRORS='' 85 REBUILD_ERRORS=''
86 86
87 while true ; do 87 while true ; do
88 case "$1" in 88 case "$1" in
89 -a|--arch) 89 -a|--arch)
90 # echo "Option ARCH: argument \`$2'" 90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then 91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")" 92 opt_a="${opt_a%)} || \$2 == \"$2\")"
93 else 93 else
94 opt_a="(\$2 == \"$2\")" 94 opt_a="(\$2 == \"$2\")"
95 fi 95 fi
96 SELECTED='y' 96 SELECTED='y'
97 shift 2 ;; 97 shift 2 ;;
98 -c|--cpu) 98 -c|--cpu)
99 # echo "Option CPU: argument \`$2'" 99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then 100 if [ "$opt_c" ] ; then
101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)" 101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
102 else 102 else
103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)" 103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
104 fi 104 fi
105 SELECTED='y' 105 SELECTED='y'
106 shift 2 ;; 106 shift 2 ;;
107 -s|--soc) 107 -s|--soc)
108 # echo "Option SoC: argument \`$2'" 108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then 109 if [ "$opt_s" ] ; then
110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)" 110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
111 else 111 else
112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)" 112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
113 fi 113 fi
114 SELECTED='y' 114 SELECTED='y'
115 shift 2 ;; 115 shift 2 ;;
116 -v|--vendor) 116 -v|--vendor)
117 # echo "Option VENDOR: argument \`$2'" 117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then 118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")" 119 opt_v="${opt_v%)} || \$5 == \"$2\")"
120 else 120 else
121 opt_v="(\$5 == \"$2\")" 121 opt_v="(\$5 == \"$2\")"
122 fi 122 fi
123 SELECTED='y' 123 SELECTED='y'
124 shift 2 ;; 124 shift 2 ;;
125 -b|--board) 125 -b|--board)
126 # echo "Option BOARD: argument \`$2'" 126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then 127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")" 128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129 else 129 else
130 # We need to check the 7th field too 130 # We need to check the 7th field too
131 # for boards whose 6th field is "-" 131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")" 132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133 fi 133 fi
134 SELECTED='y' 134 SELECTED='y'
135 shift 2 ;; 135 shift 2 ;;
136 -C|--check) 136 -C|--check)
137 CHECK='C=1' 137 CHECK='C=1'
138 shift ;; 138 shift ;;
139 -n|--continue) 139 -n|--continue)
140 CONTINUE='y' 140 CONTINUE='y'
141 shift ;; 141 shift ;;
142 -r|--rebuild-errors) 142 -r|--rebuild-errors)
143 REBUILD_ERRORS='y' 143 REBUILD_ERRORS='y'
144 shift ;; 144 shift ;;
145 -l|--list) 145 -l|--list)
146 ONLY_LIST='y' 146 ONLY_LIST='y'
147 shift ;; 147 shift ;;
148 -m|--maintainers) 148 -m|--maintainers)
149 ONLY_LIST='y' 149 ONLY_LIST='y'
150 PRINT_MAINTS='y' 150 PRINT_MAINTS='y'
151 MAINTAINERS_ONLY='y' 151 MAINTAINERS_ONLY='y'
152 shift ;; 152 shift ;;
153 -M|--mails) 153 -M|--mails)
154 ONLY_LIST='y' 154 ONLY_LIST='y'
155 PRINT_MAINTS='y' 155 PRINT_MAINTS='y'
156 shift ;; 156 shift ;;
157 -h|--help) 157 -h|--help)
158 usage ;; 158 usage ;;
159 --) 159 --)
160 shift ; break ;; 160 shift ; break ;;
161 *) 161 *)
162 echo "Internal error!" >&2 ; exit 1 ;; 162 echo "Internal error!" >&2 ; exit 1 ;;
163 esac 163 esac
164 done 164 done
165 # echo "Remaining arguments:" 165 # echo "Remaining arguments:"
166 # for arg do echo '--> '"\`$arg'" ; done 166 # for arg do echo '--> '"\`$arg'" ; done
167 167
168 FILTER="\$1 !~ /^#/" 168 FILTER="\$1 !~ /^#/"
169 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a" 169 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
170 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c" 170 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
171 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s" 171 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
172 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v" 172 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
173 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b" 173 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
174 174
175 if [ "$SELECTED" ] ; then 175 if [ "$SELECTED" ] ; then
176 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg) 176 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
177 177
178 # Make sure some boards from boards.cfg are actually found 178 # Make sure some boards from boards.cfg are actually found
179 if [ -z "$SELECTED" ] ; then 179 if [ -z "$SELECTED" ] ; then
180 echo "Error: No boards selected, invalid arguments" 180 echo "Error: No boards selected, invalid arguments"
181 exit 1 181 exit 1
182 fi 182 fi
183 fi 183 fi
184 184
185 ######################################################################### 185 #########################################################################
186 186
187 # Print statistics when we exit 187 # Print statistics when we exit
188 trap exit 1 2 3 15 188 trap exit 1 2 3 15
189 trap print_stats 0 189 trap print_stats 0
190 190
191 # Determine number of CPU cores if no default was set 191 # Determine number of CPU cores if no default was set
192 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"} 192 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
193 193
194 if [ "$BUILD_NCPUS" -gt 1 ] 194 if [ "$BUILD_NCPUS" -gt 1 ]
195 then 195 then
196 JOBS="-j $((BUILD_NCPUS + 1))" 196 JOBS="-j $((BUILD_NCPUS + 1))"
197 else 197 else
198 JOBS="" 198 JOBS=""
199 fi 199 fi
200 200
201 if [ "${MAKEALL_LOGDIR}" ] ; then 201 if [ "${MAKEALL_LOGDIR}" ] ; then
202 LOG_DIR=${MAKEALL_LOGDIR} 202 LOG_DIR=${MAKEALL_LOGDIR}
203 else 203 else
204 LOG_DIR="LOG" 204 LOG_DIR="LOG"
205 fi 205 fi
206 206
207 : ${BUILD_NBUILDS:=1} 207 : ${BUILD_NBUILDS:=1}
208 BUILD_MANY=0 208 BUILD_MANY=0
209 209
210 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then 210 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
211 BUILD_MANY=1 211 BUILD_MANY=1
212 : ${BUILD_DIR:=./build} 212 : ${BUILD_DIR:=./build}
213 mkdir -p "${BUILD_DIR}/ERR" 213 mkdir -p "${BUILD_DIR}/ERR"
214 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} + 214 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
215 fi 215 fi
216 216
217 : ${BUILD_DIR:=.} 217 : ${BUILD_DIR:=.}
218 218
219 OUTPUT_PREFIX="${BUILD_DIR}" 219 OUTPUT_PREFIX="${BUILD_DIR}"
220 220
221 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1 221 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
222 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then 222 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
223 find "${LOG_DIR}/" -type f -exec rm -f {} + 223 find "${LOG_DIR}/" -type f -exec rm -f {} +
224 fi 224 fi
225 225
226 LIST="" 226 LIST=""
227 227
228 # Keep track of the number of builds and errors 228 # Keep track of the number of builds and errors
229 ERR_CNT=0 229 ERR_CNT=0
230 ERR_LIST="" 230 ERR_LIST=""
231 WRN_CNT=0 231 WRN_CNT=0
232 WRN_LIST="" 232 WRN_LIST=""
233 TOTAL_CNT=0 233 TOTAL_CNT=0
234 SKIP_CNT=0 234 SKIP_CNT=0
235 CURRENT_CNT=0 235 CURRENT_CNT=0
236 OLDEST_IDX=1 236 OLDEST_IDX=1
237 RC=0 237 RC=0
238 238
239 # Helper funcs for parsing boards.cfg 239 # Helper funcs for parsing boards.cfg
240 targets_by_field() 240 targets_by_field()
241 { 241 {
242 field=$1 242 field=$1
243 regexp=$2 243 regexp=$2
244 244
245 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \ 245 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
246 boards.cfg 246 boards.cfg
247 } 247 }
248 248
249 targets_by_arch() { targets_by_field 2 "$@" ; } 249 targets_by_arch() { targets_by_field 2 "$@" ; }
250 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; } 250 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
251 targets_by_soc() { targets_by_field 4 "$@" ; } 251 targets_by_soc() { targets_by_field 4 "$@" ; }
252 252
253 ######################################################################### 253 #########################################################################
254 ## MPC5xx Systems 254 ## MPC5xx Systems
255 ######################################################################### 255 #########################################################################
256 256
257 LIST_5xx="$(targets_by_cpu mpc5xx)" 257 LIST_5xx="$(targets_by_cpu mpc5xx)"
258 258
259 ######################################################################### 259 #########################################################################
260 ## MPC5xxx Systems 260 ## MPC5xxx Systems
261 ######################################################################### 261 #########################################################################
262 262
263 LIST_5xxx="$(targets_by_cpu mpc5xxx)" 263 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
264 264
265 ######################################################################### 265 #########################################################################
266 ## MPC512x Systems 266 ## MPC512x Systems
267 ######################################################################### 267 #########################################################################
268 268
269 LIST_512x="$(targets_by_cpu mpc512x)" 269 LIST_512x="$(targets_by_cpu mpc512x)"
270 270
271 ######################################################################### 271 #########################################################################
272 ## MPC8xx Systems 272 ## MPC8xx Systems
273 ######################################################################### 273 #########################################################################
274 274
275 LIST_8xx="$(targets_by_cpu mpc8xx)" 275 LIST_8xx="$(targets_by_cpu mpc8xx)"
276 276
277 ######################################################################### 277 #########################################################################
278 ## PPC4xx Systems 278 ## PPC4xx Systems
279 ######################################################################### 279 #########################################################################
280 280
281 LIST_4xx="$(targets_by_cpu ppc4xx)" 281 LIST_4xx="$(targets_by_cpu ppc4xx)"
282 282
283 ######################################################################### 283 #########################################################################
284 ## MPC824x Systems 284 ## MPC824x Systems
285 ######################################################################### 285 #########################################################################
286 286
287 LIST_824x="$(targets_by_cpu mpc824x)" 287 LIST_824x="$(targets_by_cpu mpc824x)"
288 288
289 ######################################################################### 289 #########################################################################
290 ## MPC8260 Systems (includes 8250, 8255 etc.) 290 ## MPC8260 Systems (includes 8250, 8255 etc.)
291 ######################################################################### 291 #########################################################################
292 292
293 LIST_8260="$(targets_by_cpu mpc8260)" 293 LIST_8260="$(targets_by_cpu mpc8260)"
294 294
295 ######################################################################### 295 #########################################################################
296 ## MPC83xx Systems (includes 8349, etc.) 296 ## MPC83xx Systems (includes 8349, etc.)
297 ######################################################################### 297 #########################################################################
298 298
299 LIST_83xx="$(targets_by_cpu mpc83xx)" 299 LIST_83xx="$(targets_by_cpu mpc83xx)"
300 300
301 ######################################################################### 301 #########################################################################
302 ## MPC85xx Systems (includes 8540, 8560 etc.) 302 ## MPC85xx Systems (includes 8540, 8560 etc.)
303 ######################################################################### 303 #########################################################################
304 304
305 LIST_85xx="$(targets_by_cpu mpc85xx)" 305 LIST_85xx="$(targets_by_cpu mpc85xx)"
306 306
307 ######################################################################### 307 #########################################################################
308 ## MPC86xx Systems 308 ## MPC86xx Systems
309 ######################################################################### 309 #########################################################################
310 310
311 LIST_86xx="$(targets_by_cpu mpc86xx)" 311 LIST_86xx="$(targets_by_cpu mpc86xx)"
312 312
313 ######################################################################### 313 #########################################################################
314 ## 74xx/7xx Systems 314 ## 74xx/7xx Systems
315 ######################################################################### 315 #########################################################################
316 316
317 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)" 317 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
318 318
319 ######################################################################### 319 #########################################################################
320 ## PowerPC groups 320 ## PowerPC groups
321 ######################################################################### 321 #########################################################################
322 322
323 LIST_TSEC=" \ 323 LIST_TSEC=" \
324 ${LIST_83xx} \ 324 ${LIST_83xx} \
325 ${LIST_85xx} \ 325 ${LIST_85xx} \
326 ${LIST_86xx} \ 326 ${LIST_86xx} \
327 " 327 "
328 328
329 LIST_powerpc=" \ 329 LIST_powerpc=" \
330 ${LIST_5xx} \ 330 ${LIST_5xx} \
331 ${LIST_512x} \ 331 ${LIST_512x} \
332 ${LIST_5xxx} \ 332 ${LIST_5xxx} \
333 ${LIST_8xx} \ 333 ${LIST_8xx} \
334 ${LIST_824x} \ 334 ${LIST_824x} \
335 ${LIST_8260} \ 335 ${LIST_8260} \
336 ${LIST_83xx} \ 336 ${LIST_83xx} \
337 ${LIST_85xx} \ 337 ${LIST_85xx} \
338 ${LIST_86xx} \ 338 ${LIST_86xx} \
339 ${LIST_4xx} \ 339 ${LIST_4xx} \
340 ${LIST_74xx_7xx}\ 340 ${LIST_74xx_7xx}\
341 " 341 "
342 342
343 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts 343 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
344 # still using "ppc" instead of "powerpc" 344 # still using "ppc" instead of "powerpc"
345 LIST_ppc=" \ 345 LIST_ppc=" \
346 ${LIST_powerpc} \ 346 ${LIST_powerpc} \
347 " 347 "
348 348
349 ######################################################################### 349 #########################################################################
350 ## StrongARM Systems 350 ## StrongARM Systems
351 ######################################################################### 351 #########################################################################
352 352
353 LIST_SA="$(targets_by_cpu sa1100)" 353 LIST_SA="$(targets_by_cpu sa1100)"
354 354
355 ######################################################################### 355 #########################################################################
356 ## ARM7 Systems 356 ## ARM7 Systems
357 ######################################################################### 357 #########################################################################
358 358
359 LIST_ARM7="$(targets_by_cpu arm720t)" 359 LIST_ARM7="$(targets_by_cpu arm720t)"
360 360
361 ######################################################################### 361 #########################################################################
362 ## ARM9 Systems 362 ## ARM9 Systems
363 ######################################################################### 363 #########################################################################
364 364
365 LIST_ARM9="$(targets_by_cpu arm920t) \ 365 LIST_ARM9="$(targets_by_cpu arm920t) \
366 $(targets_by_cpu arm926ejs) \ 366 $(targets_by_cpu arm926ejs) \
367 $(targets_by_cpu arm946es) \ 367 $(targets_by_cpu arm946es) \
368 " 368 "
369 369
370 ######################################################################### 370 #########################################################################
371 ## ARM11 Systems 371 ## ARM11 Systems
372 ######################################################################### 372 #########################################################################
373 LIST_ARM11="$(targets_by_cpu arm1136) \ 373 LIST_ARM11="$(targets_by_cpu arm1136) \
374 $(targets_by_cpu arm1176) \ 374 $(targets_by_cpu arm1176) \
375 " 375 "
376 376
377 ######################################################################### 377 #########################################################################
378 ## ARMV7 Systems 378 ## ARMV7 Systems
379 ######################################################################### 379 #########################################################################
380 380
381 LIST_ARMV7="$(targets_by_cpu armv7)" 381 LIST_ARMV7="$(targets_by_cpu armv7)"
382 382
383 ######################################################################### 383 #########################################################################
384 ## ARMV8 Systems
385 #########################################################################
386
387 LIST_ARMV8="$(targets_by_cpu armv8)"
388
389 #########################################################################
384 ## AT91 Systems 390 ## AT91 Systems
385 ######################################################################### 391 #########################################################################
386 392
387 LIST_at91="$(targets_by_soc at91)" 393 LIST_at91="$(targets_by_soc at91)"
388 394
389 ######################################################################### 395 #########################################################################
390 ## Xscale Systems 396 ## Xscale Systems
391 ######################################################################### 397 #########################################################################
392 398
393 LIST_pxa="$(targets_by_cpu pxa)" 399 LIST_pxa="$(targets_by_cpu pxa)"
394 400
395 LIST_ixp="$(targets_by_cpu ixp)" 401 LIST_ixp="$(targets_by_cpu ixp)"
396 402
397 ######################################################################### 403 #########################################################################
398 ## SPEAr Systems 404 ## SPEAr Systems
399 ######################################################################### 405 #########################################################################
400 406
401 LIST_spear="$(targets_by_soc spear)" 407 LIST_spear="$(targets_by_soc spear)"
402 408
403 ######################################################################### 409 #########################################################################
404 ## ARM groups 410 ## ARM groups
405 ######################################################################### 411 #########################################################################
406 412
407 LIST_arm="$(targets_by_arch arm)" 413 LIST_arm="$(targets_by_arch arm | \
414 for ARMV8_TARGET in $LIST_ARMV8; \
415 do sed "/$ARMV8_TARGET/d"; \
416 done) \
417 "
408 418
409 ######################################################################### 419 #########################################################################
410 ## MIPS Systems (default = big endian) 420 ## MIPS Systems (default = big endian)
411 ######################################################################### 421 #########################################################################
412 422
413 LIST_mips4kc=" \ 423 LIST_mips4kc=" \
414 incaip \ 424 incaip \
415 incaip_100MHz \ 425 incaip_100MHz \
416 incaip_133MHz \ 426 incaip_133MHz \
417 incaip_150MHz \ 427 incaip_150MHz \
418 qemu_mips \ 428 qemu_mips \
419 vct_platinum \ 429 vct_platinum \
420 vct_platinum_small \ 430 vct_platinum_small \
421 vct_platinum_onenand \ 431 vct_platinum_onenand \
422 vct_platinum_onenand_small \ 432 vct_platinum_onenand_small \
423 vct_platinumavc \ 433 vct_platinumavc \
424 vct_platinumavc_small \ 434 vct_platinumavc_small \
425 vct_platinumavc_onenand \ 435 vct_platinumavc_onenand \
426 vct_platinumavc_onenand_small \ 436 vct_platinumavc_onenand_small \
427 vct_premium \ 437 vct_premium \
428 vct_premium_small \ 438 vct_premium_small \
429 vct_premium_onenand \ 439 vct_premium_onenand \
430 vct_premium_onenand_small \ 440 vct_premium_onenand_small \
431 " 441 "
432 442
433 LIST_au1xx0=" \ 443 LIST_au1xx0=" \
434 dbau1000 \ 444 dbau1000 \
435 dbau1100 \ 445 dbau1100 \
436 dbau1500 \ 446 dbau1500 \
437 dbau1550 \ 447 dbau1550 \
438 " 448 "
439 449
440 LIST_mips=" \ 450 LIST_mips=" \
441 ${LIST_mips4kc} \ 451 ${LIST_mips4kc} \
442 ${LIST_mips5kc} \ 452 ${LIST_mips5kc} \
443 ${LIST_au1xx0} \ 453 ${LIST_au1xx0} \
444 " 454 "
445 455
446 ######################################################################### 456 #########################################################################
447 ## MIPS Systems (little endian) 457 ## MIPS Systems (little endian)
448 ######################################################################### 458 #########################################################################
449 459
450 LIST_au1xx0_el=" \ 460 LIST_au1xx0_el=" \
451 dbau1550_el \ 461 dbau1550_el \
452 pb1000 \ 462 pb1000 \
453 " 463 "
454 LIST_mips_el=" \ 464 LIST_mips_el=" \
455 ${LIST_au1xx0_el} \ 465 ${LIST_au1xx0_el} \
456 " 466 "
457 ######################################################################### 467 #########################################################################
458 ## OpenRISC Systems 468 ## OpenRISC Systems
459 ######################################################################### 469 #########################################################################
460 470
461 LIST_openrisc="$(targets_by_arch openrisc)" 471 LIST_openrisc="$(targets_by_arch openrisc)"
462 472
463 ######################################################################### 473 #########################################################################
464 ## x86 Systems 474 ## x86 Systems
465 ######################################################################### 475 #########################################################################
466 476
467 LIST_x86="$(targets_by_arch x86)" 477 LIST_x86="$(targets_by_arch x86)"
468 478
469 ######################################################################### 479 #########################################################################
470 ## Nios-II Systems 480 ## Nios-II Systems
471 ######################################################################### 481 #########################################################################
472 482
473 LIST_nios2="$(targets_by_arch nios2)" 483 LIST_nios2="$(targets_by_arch nios2)"
474 484
475 ######################################################################### 485 #########################################################################
476 ## MicroBlaze Systems 486 ## MicroBlaze Systems
477 ######################################################################### 487 #########################################################################
478 488
479 LIST_microblaze="$(targets_by_arch microblaze)" 489 LIST_microblaze="$(targets_by_arch microblaze)"
480 490
481 ######################################################################### 491 #########################################################################
482 ## ColdFire Systems 492 ## ColdFire Systems
483 ######################################################################### 493 #########################################################################
484 494
485 LIST_m68k="$(targets_by_arch m68k)" 495 LIST_m68k="$(targets_by_arch m68k)"
486 LIST_coldfire=${LIST_m68k} 496 LIST_coldfire=${LIST_m68k}
487 497
488 ######################################################################### 498 #########################################################################
489 ## AVR32 Systems 499 ## AVR32 Systems
490 ######################################################################### 500 #########################################################################
491 501
492 LIST_avr32="$(targets_by_arch avr32)" 502 LIST_avr32="$(targets_by_arch avr32)"
493 503
494 ######################################################################### 504 #########################################################################
495 ## Blackfin Systems 505 ## Blackfin Systems
496 ######################################################################### 506 #########################################################################
497 507
498 LIST_blackfin="$(targets_by_arch blackfin)" 508 LIST_blackfin="$(targets_by_arch blackfin)"
499 509
500 ######################################################################### 510 #########################################################################
501 ## SH Systems 511 ## SH Systems
502 ######################################################################### 512 #########################################################################
503 513
504 LIST_sh2="$(targets_by_cpu sh2)" 514 LIST_sh2="$(targets_by_cpu sh2)"
505 LIST_sh3="$(targets_by_cpu sh3)" 515 LIST_sh3="$(targets_by_cpu sh3)"
506 LIST_sh4="$(targets_by_cpu sh4)" 516 LIST_sh4="$(targets_by_cpu sh4)"
507 517
508 LIST_sh="$(targets_by_arch sh)" 518 LIST_sh="$(targets_by_arch sh)"
509 519
510 ######################################################################### 520 #########################################################################
511 ## SPARC Systems 521 ## SPARC Systems
512 ######################################################################### 522 #########################################################################
513 523
514 LIST_sparc="$(targets_by_arch sparc)" 524 LIST_sparc="$(targets_by_arch sparc)"
515 525
516 ######################################################################### 526 #########################################################################
517 ## NDS32 Systems 527 ## NDS32 Systems
518 ######################################################################### 528 #########################################################################
519 529
520 LIST_nds32="$(targets_by_arch nds32)" 530 LIST_nds32="$(targets_by_arch nds32)"
521 531
522 #----------------------------------------------------------------------- 532 #-----------------------------------------------------------------------
523 533
524 get_target_location() { 534 get_target_location() {
525 local target=$1 535 local target=$1
526 local BOARD_NAME="" 536 local BOARD_NAME=""
527 local CONFIG_NAME="" 537 local CONFIG_NAME=""
528 local board="" 538 local board=""
529 local vendor="" 539 local vendor=""
530 540
531 # Automatic mode 541 # Automatic mode
532 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` 542 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
533 if [ -z "${line}" ] ; then echo "" ; return ; fi 543 if [ -z "${line}" ] ; then echo "" ; return ; fi
534 544
535 set ${line} 545 set ${line}
536 546
537 CONFIG_NAME="${7%_config}" 547 CONFIG_NAME="${7%_config}"
538 548
539 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_config}" 549 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_config}"
540 550
541 if [ $# -gt 5 ]; then 551 if [ $# -gt 5 ]; then
542 if [ "$6" = "-" ] ; then 552 if [ "$6" = "-" ] ; then
543 board=${BOARD_NAME} 553 board=${BOARD_NAME}
544 else 554 else
545 board="$6" 555 board="$6"
546 fi 556 fi
547 fi 557 fi
548 558
549 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5" 559 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
550 [ $# -gt 6 ] && [ "$8" != "-" ] && { 560 [ $# -gt 6 ] && [ "$8" != "-" ] && {
551 tmp="${8%:*}" 561 tmp="${8%:*}"
552 if [ "$tmp" ] ; then 562 if [ "$tmp" ] ; then
553 CONFIG_NAME="$tmp" 563 CONFIG_NAME="$tmp"
554 fi 564 fi
555 } 565 }
556 566
557 # Assign board directory to BOARDIR variable 567 # Assign board directory to BOARDIR variable
558 if [ "${vendor}" == "-" ] ; then 568 if [ "${vendor}" == "-" ] ; then
559 BOARDDIR=${board} 569 BOARDDIR=${board}
560 else 570 else
561 BOARDDIR=${vendor}/${board} 571 BOARDDIR=${vendor}/${board}
562 fi 572 fi
563 573
564 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}" 574 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
565 } 575 }
566 576
567 get_target_maintainers() { 577 get_target_maintainers() {
568 local name=`echo $1 | cut -d : -f 3` 578 local name=`echo $1 | cut -d : -f 3`
569 579
570 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` 580 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
571 if [ -z "${line}" ]; then 581 if [ -z "${line}" ]; then
572 echo "" 582 echo ""
573 return ; 583 return ;
574 fi 584 fi
575 585
576 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'` 586 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
577 [ "$mails" == "-" ] && mails="" 587 [ "$mails" == "-" ] && mails=""
578 echo "$mails" 588 echo "$mails"
579 } 589 }
580 590
581 get_target_arch() { 591 get_target_arch() {
582 local target=$1 592 local target=$1
583 593
584 # Automatic mode 594 # Automatic mode
585 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` 595 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
586 596
587 if [ -z "${line}" ] ; then echo "" ; return ; fi 597 if [ -z "${line}" ] ; then echo "" ; return ; fi
588 598
589 set ${line} 599 set ${line}
590 echo "$2" 600 echo "$2"
591 } 601 }
592 602
593 list_target() { 603 list_target() {
594 if [ "$PRINT_MAINTS" != 'y' ] ; then 604 if [ "$PRINT_MAINTS" != 'y' ] ; then
595 echo "$1" 605 echo "$1"
596 return 606 return
597 fi 607 fi
598 608
599 echo -n "$1:" 609 echo -n "$1:"
600 610
601 local loc=`get_target_location $1` 611 local loc=`get_target_location $1`
602 612
603 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi 613 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
604 614
605 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"` 615 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
606 616
607 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then 617 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
608 618
609 local dir=`echo ${loc} | cut -d ":" -f 2` 619 local dir=`echo ${loc} | cut -d ":" -f 2`
610 local cfg=`echo ${loc} | cut -d ":" -f 1` 620 local cfg=`echo ${loc} | cut -d ":" -f 1`
611 local git_result=`git log --format=%aE board/${dir} \ 621 local git_result=`git log --format=%aE board/${dir} \
612 include/configs/${cfg}.h | grep "@"` 622 include/configs/${cfg}.h | grep "@"`
613 local git_result_recent=`echo ${git_result} | tr " " "\n" | \ 623 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
614 head -n 3` 624 head -n 3`
615 local git_result_top=`echo ${git_result} | tr " " "\n" | \ 625 local git_result_top=`echo ${git_result} | tr " " "\n" | \
616 sort | uniq -c | sort -nr | head -n 3 | \ 626 sort | uniq -c | sort -nr | head -n 3 | \
617 sed "s/^ \+[0-9]\+ \+//"` 627 sed "s/^ \+[0-9]\+ \+//"`
618 628
619 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \ 629 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
620 sort -u | tr "\n" " " | sed "s/ $//" ; 630 sort -u | tr "\n" " " | sed "s/ $//" ;
621 else 631 else
622 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \ 632 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
623 sed "s/ $//" ; 633 sed "s/ $//" ;
624 fi 634 fi
625 635
626 echo "" 636 echo ""
627 } 637 }
628 638
629 # Each finished build will have a file called ${donep}${n}, 639 # Each finished build will have a file called ${donep}${n},
630 # where n is the index of the build. Each build 640 # where n is the index of the build. Each build
631 # we've already noted as finished will have ${skipp}${n}. 641 # we've already noted as finished will have ${skipp}${n}.
632 # The code managing the build process will use this information 642 # The code managing the build process will use this information
633 # to ensure that only BUILD_NBUILDS builds are in flight at once 643 # to ensure that only BUILD_NBUILDS builds are in flight at once
634 donep="${LOG_DIR}/._done_" 644 donep="${LOG_DIR}/._done_"
635 skipp="${LOG_DIR}/._skip_" 645 skipp="${LOG_DIR}/._skip_"
636 646
637 build_target_killed() { 647 build_target_killed() {
638 echo "Aborted $target build." 648 echo "Aborted $target build."
639 # Remove the logs for this board since it was aborted 649 # Remove the logs for this board since it was aborted
640 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR 650 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
641 exit 651 exit
642 } 652 }
643 653
644 build_target() { 654 build_target() {
645 target=$1 655 target=$1
646 build_idx=$2 656 build_idx=$2
647 657
648 if [ "$ONLY_LIST" == 'y' ] ; then 658 if [ "$ONLY_LIST" == 'y' ] ; then
649 list_target ${target} 659 list_target ${target}
650 return 660 return
651 fi 661 fi
652 662
653 if [ $BUILD_MANY == 1 ] ; then 663 if [ $BUILD_MANY == 1 ] ; then
654 output_dir="${OUTPUT_PREFIX}/${target}" 664 output_dir="${OUTPUT_PREFIX}/${target}"
655 mkdir -p "${output_dir}" 665 mkdir -p "${output_dir}"
656 trap build_target_killed TERM 666 trap build_target_killed TERM
657 else 667 else
658 output_dir="${OUTPUT_PREFIX}" 668 output_dir="${OUTPUT_PREFIX}"
659 fi 669 fi
660 670
661 export BUILD_DIR="${output_dir}" 671 export BUILD_DIR="${output_dir}"
662 672
663 target_arch=$(get_target_arch ${target}) 673 target_arch=$(get_target_arch ${target})
664 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'` 674 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
665 if [ "${cross_toolchain}" ] ; then 675 if [ "${cross_toolchain}" ] ; then
666 MAKE="make CROSS_COMPILE=${cross_toolchain}" 676 MAKE="make CROSS_COMPILE=${cross_toolchain}"
667 elif [ "${CROSS_COMPILE}" ] ; then 677 elif [ "${CROSS_COMPILE}" ] ; then
668 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}" 678 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
669 else 679 else
670 MAKE=make 680 MAKE=make
671 fi 681 fi
672 682
673 ${MAKE} distclean >/dev/null 683 ${MAKE} distclean >/dev/null
674 ${MAKE} -s ${target}_config 684 ${MAKE} -s ${target}_config
675 685
676 ${MAKE} ${JOBS} ${CHECK} all \ 686 ${MAKE} ${JOBS} ${CHECK} all \
677 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR 687 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
678 688
679 # Check for 'make' errors 689 # Check for 'make' errors
680 if [ ${PIPESTATUS[0]} -ne 0 ] ; then 690 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
681 RC=1 691 RC=1
682 fi 692 fi
683 693
684 if [ $BUILD_MANY == 1 ] ; then 694 if [ $BUILD_MANY == 1 ] ; then
685 trap - TERM 695 trap - TERM
686 696
687 ${MAKE} -s tidy 697 ${MAKE} -s tidy
688 698
689 if [ -s ${LOG_DIR}/${target}.ERR ] ; then 699 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
690 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target} 700 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
691 else 701 else
692 rm ${LOG_DIR}/${target}.ERR 702 rm ${LOG_DIR}/${target}.ERR
693 fi 703 fi
694 else 704 else
695 if [ -s ${LOG_DIR}/${target}.ERR ] ; then 705 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
696 if grep -iw error ${LOG_DIR}/${target}.ERR ; then 706 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
697 : $(( ERR_CNT += 1 )) 707 : $(( ERR_CNT += 1 ))
698 ERR_LIST="${ERR_LIST} $target" 708 ERR_LIST="${ERR_LIST} $target"
699 else 709 else
700 : $(( WRN_CNT += 1 )) 710 : $(( WRN_CNT += 1 ))
701 WRN_LIST="${WRN_LIST} $target" 711 WRN_LIST="${WRN_LIST} $target"
702 fi 712 fi
703 else 713 else
704 rm ${LOG_DIR}/${target}.ERR 714 rm ${LOG_DIR}/${target}.ERR
705 fi 715 fi
706 fi 716 fi
707 717
708 OBJS=${output_dir}/u-boot 718 OBJS=${output_dir}/u-boot
709 if [ -e ${output_dir}/spl/u-boot-spl ]; then 719 if [ -e ${output_dir}/spl/u-boot-spl ]; then
710 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl" 720 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
711 fi 721 fi
712 722
713 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG 723 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
714 724
715 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR" 725 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
716 726
717 touch "${donep}${build_idx}" 727 touch "${donep}${build_idx}"
718 } 728 }
719 729
720 manage_builds() { 730 manage_builds() {
721 search_idx=${OLDEST_IDX} 731 search_idx=${OLDEST_IDX}
722 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi 732 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
723 733
724 while true; do 734 while true; do
725 if [ -e "${donep}${search_idx}" ] ; then 735 if [ -e "${donep}${search_idx}" ] ; then
726 : $(( CURRENT_CNT-- )) 736 : $(( CURRENT_CNT-- ))
727 [ ${OLDEST_IDX} -eq ${search_idx} ] && 737 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
728 : $(( OLDEST_IDX++ )) 738 : $(( OLDEST_IDX++ ))
729 739
730 # Only want to count it once 740 # Only want to count it once
731 rm -f "${donep}${search_idx}" 741 rm -f "${donep}${search_idx}"
732 touch "${skipp}${search_idx}" 742 touch "${skipp}${search_idx}"
733 elif [ -e "${skipp}${search_idx}" ] ; then 743 elif [ -e "${skipp}${search_idx}" ] ; then
734 [ ${OLDEST_IDX} -eq ${search_idx} ] && 744 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
735 : $(( OLDEST_IDX++ )) 745 : $(( OLDEST_IDX++ ))
736 fi 746 fi
737 : $(( search_idx++ )) 747 : $(( search_idx++ ))
738 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then 748 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
739 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then 749 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
740 search_idx=${OLDEST_IDX} 750 search_idx=${OLDEST_IDX}
741 sleep 1 751 sleep 1
742 else 752 else
743 break 753 break
744 fi 754 fi
745 fi 755 fi
746 done 756 done
747 } 757 }
748 758
749 build_targets() { 759 build_targets() {
750 for t in "$@" ; do 760 for t in "$@" ; do
751 # If a LIST_xxx var exists, use it. But avoid variable 761 # If a LIST_xxx var exists, use it. But avoid variable
752 # expansion in the eval when a board name contains certain 762 # expansion in the eval when a board name contains certain
753 # characters that the shell interprets. 763 # characters that the shell interprets.
754 case ${t} in 764 case ${t} in
755 *[-+=]*) list= ;; 765 *[-+=]*) list= ;;
756 *) list=$(eval echo '${LIST_'$t'}') ;; 766 *) list=$(eval echo '${LIST_'$t'}') ;;
757 esac 767 esac
758 if [ -n "${list}" ] ; then 768 if [ -n "${list}" ] ; then
759 build_targets ${list} 769 build_targets ${list}
760 else 770 else
761 : $((TOTAL_CNT += 1)) 771 : $((TOTAL_CNT += 1))
762 : $((CURRENT_CNT += 1)) 772 : $((CURRENT_CNT += 1))
763 rm -f "${donep}${TOTAL_CNT}" 773 rm -f "${donep}${TOTAL_CNT}"
764 rm -f "${skipp}${TOTAL_CNT}" 774 rm -f "${skipp}${TOTAL_CNT}"
765 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then 775 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
766 : $((SKIP_CNT += 1)) 776 : $((SKIP_CNT += 1))
767 touch "${donep}${TOTAL_CNT}" 777 touch "${donep}${TOTAL_CNT}"
768 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then 778 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
769 : $((SKIP_CNT += 1)) 779 : $((SKIP_CNT += 1))
770 touch "${donep}${TOTAL_CNT}" 780 touch "${donep}${TOTAL_CNT}"
771 else 781 else
772 if [ $BUILD_MANY == 1 ] ; then 782 if [ $BUILD_MANY == 1 ] ; then
773 build_target ${t} ${TOTAL_CNT} & 783 build_target ${t} ${TOTAL_CNT} &
774 else 784 else
775 CUR_TGT="${t}" 785 CUR_TGT="${t}"
776 build_target ${t} ${TOTAL_CNT} 786 build_target ${t} ${TOTAL_CNT}
777 CUR_TGT='' 787 CUR_TGT=''
778 fi 788 fi
779 fi 789 fi
780 fi 790 fi
781 791
782 # We maintain a running count of all the builds we have done. 792 # We maintain a running count of all the builds we have done.
783 # Each finished build will have a file called ${donep}${n}, 793 # Each finished build will have a file called ${donep}${n},
784 # where n is the index of the build. Each build 794 # where n is the index of the build. Each build
785 # we've already noted as finished will have ${skipp}${n}. 795 # we've already noted as finished will have ${skipp}${n}.
786 # We track the current index via TOTAL_CNT, and the oldest 796 # We track the current index via TOTAL_CNT, and the oldest
787 # index. When we exceed the maximum number of parallel builds, 797 # index. When we exceed the maximum number of parallel builds,
788 # We look from oldest to current for builds that have completed, 798 # We look from oldest to current for builds that have completed,
789 # and update the current count and oldest index as appropriate. 799 # and update the current count and oldest index as appropriate.
790 # If we've gone through the entire list, wait a second, and 800 # If we've gone through the entire list, wait a second, and
791 # reprocess the entire list until we find a build that has 801 # reprocess the entire list until we find a build that has
792 # completed 802 # completed
793 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then 803 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
794 manage_builds 804 manage_builds
795 fi 805 fi
796 done 806 done
797 } 807 }
798 808
799 #----------------------------------------------------------------------- 809 #-----------------------------------------------------------------------
800 810
801 kill_children() { 811 kill_children() {
802 local OS=$(uname -s) 812 local OS=$(uname -s)
803 local children="" 813 local children=""
804 case "${OS}" in 814 case "${OS}" in
805 "Darwin") 815 "Darwin")
806 # Mac OS X is known to have BSD style ps 816 # Mac OS X is known to have BSD style ps
807 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d") 817 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
808 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d") 818 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
809 ;; 819 ;;
810 *) 820 *)
811 # everything else tries the GNU style 821 # everything else tries the GNU style
812 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ') 822 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
813 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d") 823 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
814 ;; 824 ;;
815 esac 825 esac
816 826
817 kill $children 2> /dev/null 827 kill $children 2> /dev/null
818 wait $children 2> /dev/null 828 wait $children 2> /dev/null
819 829
820 exit 830 exit
821 } 831 }
822 832
823 print_stats() { 833 print_stats() {
824 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi 834 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
825 835
826 # Only count boards that completed 836 # Only count boards that completed
827 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`)) 837 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
828 838
829 rm -f ${donep}* ${skipp}* 839 rm -f ${donep}* ${skipp}*
830 840
831 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then 841 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
832 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/` 842 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
833 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done` 843 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
834 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'` 844 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
835 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/` 845 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
836 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done` 846 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
837 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'` 847 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
838 else 848 else
839 # Remove the logs for any board that was interrupted 849 # Remove the logs for any board that was interrupted
840 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR 850 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
841 fi 851 fi
842 852
843 : $((TOTAL_CNT -= ${SKIP_CNT})) 853 : $((TOTAL_CNT -= ${SKIP_CNT}))
844 echo "" 854 echo ""
845 echo "--------------------- SUMMARY ----------------------------" 855 echo "--------------------- SUMMARY ----------------------------"
846 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then 856 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
847 echo "Boards skipped: ${SKIP_CNT}" 857 echo "Boards skipped: ${SKIP_CNT}"
848 fi 858 fi
849 echo "Boards compiled: ${TOTAL_CNT}" 859 echo "Boards compiled: ${TOTAL_CNT}"
850 if [ ${ERR_CNT} -gt 0 ] ; then 860 if [ ${ERR_CNT} -gt 0 ] ; then
851 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )" 861 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
852 fi 862 fi
853 if [ ${WRN_CNT} -gt 0 ] ; then 863 if [ ${WRN_CNT} -gt 0 ] ; then
854 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )" 864 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
855 fi 865 fi
856 echo "----------------------------------------------------------" 866 echo "----------------------------------------------------------"
857 867
858 if [ $BUILD_MANY == 1 ] ; then 868 if [ $BUILD_MANY == 1 ] ; then
859 kill_children 869 kill_children
860 fi 870 fi
861 871
862 exit $RC 872 exit $RC
863 } 873 }
864 874
865 #----------------------------------------------------------------------- 875 #-----------------------------------------------------------------------
866 876
867 # Build target groups selected by options, plus any command line args 877 # Build target groups selected by options, plus any command line args
868 set -- ${SELECTED} "$@" 878 set -- ${SELECTED} "$@"
869 # run PowerPC by default 879 # run PowerPC by default
870 [ $# = 0 ] && set -- powerpc 880 [ $# = 0 ] && set -- powerpc
871 build_targets "$@" 881 build_targets "$@"
872 wait 882 wait
873 883